Bug 1302963 - Custom STI templates [NEEDINFO]
Custom STI templates
Status: NEW
Product: OpenShift Container Platform
Classification: Red Hat
Component: RFE (Show other bugs)
3.1.0
Unspecified Unspecified
high Severity medium
: ---
: ---
Assigned To: Ben Parees
Johnny Liu
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2016-01-29 02:17 EST by Jaspreet Kaur
Modified: 2018-01-08 18:03 EST (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
erich: needinfo? (jkaur)


Attachments (Terms of Use)

  None (edit)
Description Jaspreet Kaur 2016-01-29 02:17:37 EST
3. What is the nature and description of the request?  

STI implementation at present generates configurations (BC, DC, IS, etc) from some sort of template, incorporated inside the STI process. We would like to have ability to provide our custom template for STI to generate configuration from. 

      
4. Why does the customer need this? (List the business requirements here)  

We would like to use encrypted traffic from POD to LoadBalander/Router. For this we need ability to pass certificates to each and every POD running in our infrastructure. "Bake in" certificates to the images is not an option. All other parts of infrastructure we can control, but not STI.

We have certificates created as secrets for each project separately by infrastructure. And we would like to mount this secret to ALL STI builds. This requires modification to how STI generates objects/configurations

      
5. How would the customer like to achieve this? (List the functional requirements here)

We want to use STI provided capabilities (Where you just paste your source code repository and chose builder Image) and all configurations is generated for you by STI. We need to be able to mount secrets to these configurations. And not only secret but to change other options too like replications number, triggers, etc. 

In example how many replicated PODs we want to have by default, some default triggers, etc. This goes to wider picture - how to define default values for other elements too, including default secrets. This would be wider requirement.

"Platform level secrets", which would be per project basis present by default for all builds.

      
6. For each functional requirement listed, specify how Red Hat and the customer can test to confirm the requirement is successfully implemented.  

Need a default way to provide different objects  that we want so that it could be created using repo/image or docker file while creating applications.

7. Is there already an existing RFE upstream or in Red Hat Bugzilla?  

No

8. Does the customer have any specific timeline dependencies and which release would they like to target?

ASAP   
      
9. Is the sales team involved in this request and do they have any additional input? 
No
      
10. List any affected packages or components.  
      
11. Would the customer be able to assist in testing this functionality if implemented?
Comment 2 Ben Parees 2016-04-13 10:00:52 EDT
I think STI in this RFE is really referring to new-app.
Comment 3 Mangirdas 2016-04-20 02:35:34 EDT
(In reply to Ben Parees from comment #2)
> I think STI in this RFE is really referring to new-app.

Yes. And app configuration, being called when Builders is being invoked via UI too.
Comment 5 Mangirdas 2016-08-10 03:21:50 EDT
Any news on this one Ben?
Comment 6 Ben Parees 2016-08-10 08:47:06 EDT
It's being tracked in our trello backlog:
https://trello.com/c/iotn8FCo/873-8-make-new-app-generate-based-on-skeleton-definition-evg

but we don't have a current ETA for when we'd implement it.
Comment 7 Mangirdas 2016-08-10 08:53:32 EDT
Awesome. If you need more details, let me know. Its already third place where I'm running to same challenge.
+ I saw when you do oc new-app you get this generated:
"type": "Git",
            "git": {
                "uri": "ssh://git@stash.gto.intranet.db.com:7999/paas/example-spring-boot-freemakers.git",
                "ref": "master"
            },
            "secrets": null
        },

where null is comming from? Is it possible to populate it somehow? Can you please point to Go code where it comes from (lost little bit in this one).
Comment 8 Ben Parees 2016-08-10 09:05:08 EDT
it's not possible to populate it, you're just seeing the default value being displayed, but there is no way to set a value for it via new-app, you have to edit the buildconfig after the fact.
Comment 9 Mangirdas 2016-08-10 09:07:54 EDT
Ok, so the only available option is custom S2I and before this "hits" next release we will need to come up with different flow.

Note You need to log in before you can comment on or make changes to this bug.